Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 4105)
+++ /palm/trunk/SOURCE/Makefile	(revision 4106)
@@ -605,6 +605,5 @@
 	data_output_binary_module.f90 \
 	data_output_module.f90 \
-	data_output_netcdf4_parallel_module.f90 \
-	data_output_netcdf4_serial_module.f90 \
+	data_output_netcdf4_module.f90 \
 	data_output_2d.f90 \
 	data_output_3d.f90 \
@@ -915,6 +914,5 @@
 data_output_module.o: \
 	data_output_binary_module.o \
-	data_output_netcdf4_parallel_module.o \
-	data_output_netcdf4_serial_module.o \
+	data_output_netcdf4_module.o \
 	mod_kinds.o
 data_output_mask.o: \
@@ -930,7 +928,5 @@
 	salsa_mod.o \
 	surface_mod.o
-data_output_netcdf4_parallel_module.o: \
-	mod_kinds.o
-data_output_netcdf4_serial_module.o: \
+data_output_netcdf4_module.o: \
 	mod_kinds.o
 data_output_profiles.o: \
Index: /palm/trunk/SOURCE/data_output_binary_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_binary_module.f90	(revision 4105)
+++ /palm/trunk/SOURCE/data_output_binary_module.f90	(revision 4106)
@@ -20,6 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
@@ -36,7 +36,5 @@
 !> Binary output module to write output data into binary files.
 !>
-!> @todo Think of removing 'is_init' as its value can be derived from the return
-!>       value of 'return_value'.
-!> @todo Get return value of write statements.
+!> @todo Get iostat value of write statements.
 !--------------------------------------------------------------------------------------------------!
 MODULE data_output_binary_module
@@ -57,4 +55,5 @@
 
    CHARACTER(LEN=*), PARAMETER ::  config_file_name = 'BINARY_TO_NETCDF_CONFIG'  !< name of config file
+   CHARACTER(LEN=*), PARAMETER ::  mode_binary = 'binary'                        !< string to select operation mode of module
    CHARACTER(LEN=*), PARAMETER ::  prefix = 'BIN_'                               !< file prefix for binary files
 
@@ -156,9 +155,10 @@
 !> Open binary file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE binary_open_file( filename, file_id, return_value )
+SUBROUTINE binary_open_file( mode, filename, file_id, return_value )
 
    CHARACTER(LEN=charlen)             ::  bin_filename = ''  !< actual name of binary file
    CHARACTER(LEN=charlen), INTENT(IN) ::  filename           !< name of file
    CHARACTER(LEN=7)                   ::  myid_char          !< string containing value of myid with leading zeros
+   CHARACTER(LEN=*),       INTENT(IN) ::  mode               !< operation mode
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'binary_open_file'  !< name of this routine
@@ -180,5 +180,5 @@
       WRITE( myid_char, '("_",I6.6)' )  myid
    ELSE
-      CALL internal_message( 'debug', routine_name // 'MPI_COMM_RANK error' )
+      CALL internal_message( 'debug', routine_name // ': MPI_COMM_RANK error' )
    ENDIF
 #else
@@ -186,4 +186,7 @@
    myid_char = '_' // REPEAT('0', 6)
 #endif
+
+   !-- Check mode (not required, added for compatibility reasons)
+   IF ( TRIM( mode ) == mode_binary )  CONTINUE
 
    !-- Open binary config file for combining script
@@ -356,5 +359,5 @@
       return_value = 1
       CALL internal_message( 'error', TRIM( routine_name ) // &
-                                      ': attribute "' // TRIM( att_name ) // '": no value given' )
+                             ': attribute "' // TRIM( att_name ) // '": no value given' )
    ENDIF
 
@@ -367,10 +370,11 @@
 !> values to be later written to file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE binary_init_dimension( file_id, dim_id, var_id, &
-              dim_name, dim_type, dim_length, is_init, return_value )
+SUBROUTINE binary_init_dimension( mode, file_id, dim_id, var_id, &
+              dim_name, dim_type, dim_length, return_value )
 
    CHARACTER(LEN=charlen), INTENT(IN) ::  dim_name  !< name of dimension
    CHARACTER(LEN=charlen), INTENT(IN) ::  dim_type  !< data type of dimension
    CHARACTER(LEN=charlen)             ::  out_str   !< output string
+   CHARACTER(LEN=*),       INTENT(IN) ::  mode      !< operation mode
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'binary_init_dimension'  !< name of this routine
@@ -382,10 +386,11 @@
    INTEGER(iwp), INTENT(OUT) ::  var_id        !< variable ID
 
-   LOGICAL, INTENT(OUT) ::  is_init  !< true if dimension is initialized
-
 
    return_value = 0
 
    CALL internal_message( 'debug', routine_name // ': init dimension ' // TRIM( dim_name ) )
+
+   !-- Check mode (not required, added for compatibility reasons only)
+   IF ( TRIM( mode ) == mode_binary )  CONTINUE
 
    !-- Assign dimension ID
@@ -402,8 +407,7 @@
 
    !-- Define variable associated with dimension
-   CALL binary_init_variable( file_id, var_id, dim_name, dim_type, &
-                              (/dim_id/), is_init, .TRUE., return_value )
+   CALL binary_init_variable( mode, file_id, var_id, dim_name, dim_type, (/dim_id/), &
+                              is_global=.TRUE., return_value=return_value )
    IF ( return_value /= 0 )  THEN
-      is_init = .FALSE.
       CALL internal_message( 'error', routine_name // &
                                       ': init dimension "' // TRIM( dim_name ) // '"' )
@@ -417,10 +421,11 @@
 !> Initialize variable. Write information of variable into file header.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE binary_init_variable( file_id, var_id, var_name, var_type, &
-                                 var_dim_ids, is_init, is_global, return_value )
+SUBROUTINE binary_init_variable( mode, file_id, var_id, var_name, var_type, &
+                                 var_dim_ids, is_global, return_value )
 
    CHARACTER(LEN=charlen)             ::  out_str   !< output string
    CHARACTER(LEN=charlen), INTENT(IN) ::  var_name  !< name of variable
    CHARACTER(LEN=charlen), INTENT(IN) ::  var_type  !< data type of variable
+   CHARACTER(LEN=*),       INTENT(IN) ::  mode      !< operation mode
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'binary_init_variable'  !< name of this routine
@@ -433,5 +438,4 @@
 
    LOGICAL, INTENT(IN)  ::  is_global  !< true if variable is global (same on all PE)
-   LOGICAL, INTENT(OUT) ::  is_init    !< true if variable is initialized
 
 
@@ -440,5 +444,9 @@
    CALL internal_message( 'debug', routine_name // ': init variable ' // TRIM( var_name ) )
 
-   IF ( is_global )  CONTINUE  ! reqired to prevent compiler warning
+   !-- Check mode (not required, added for compatibility reasons only)
+   IF ( TRIM( mode ) == mode_binary )  CONTINUE
+
+   !-- Check if variable is global (not required, added for compatibility reasons only)
+   IF ( is_global )  CONTINUE
 
    !-- Assign variable ID
@@ -454,7 +462,4 @@
    WRITE( file_id )  SIZE( var_dim_ids )
    WRITE( file_id )  var_dim_ids
-
-   !-- Variable is initialised
-   is_init = return_value == 0
 
 END SUBROUTINE binary_init_variable
@@ -504,4 +509,6 @@
               return_value )
 
+   CHARACTER(LEN=charlen) ::  out_str  !< output string
+
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'binary_write_variable'  !< name of this routine
 
@@ -567,70 +574,124 @@
       !-- 8bit integer output
       IF ( PRESENT( var_int8_0d ) )  THEN
+         out_str = 'int8'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int8_0d
       ELSEIF ( PRESENT( var_int8_1d ) )  THEN
+         out_str = 'int8'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int8_1d
       ELSEIF ( PRESENT( var_int8_2d ) )  THEN
+         out_str = 'int8'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int8_2d
       ELSEIF ( PRESENT( var_int8_3d ) )  THEN
+         out_str = 'int8'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int8_3d
       !-- 16bit integer output
       ELSEIF ( PRESENT( var_int16_0d ) )  THEN
+         out_str = 'int16'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int16_0d
       ELSEIF ( PRESENT( var_int16_1d ) )  THEN
+         out_str = 'int16'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int16_1d
       ELSEIF ( PRESENT( var_int16_2d ) )  THEN
+         out_str = 'int16'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int16_2d
       ELSEIF ( PRESENT( var_int16_3d ) )  THEN
+         out_str = 'int16'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int16_3d
       !-- 32bit integer output
       ELSEIF ( PRESENT( var_int32_0d ) )  THEN
+         out_str = 'int32'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int32_0d
       ELSEIF ( PRESENT( var_int32_1d ) )  THEN
+         out_str = 'int32'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int32_1d
       ELSEIF ( PRESENT( var_int32_2d ) )  THEN
+         out_str = 'int32'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int32_2d
       ELSEIF ( PRESENT( var_int32_3d ) )  THEN
+         out_str = 'int32'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_int32_3d
       !-- working-precision integer output
       ELSEIF ( PRESENT( var_intwp_0d ) )  THEN
+         out_str = 'intwp'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_intwp_0d
       ELSEIF ( PRESENT( var_intwp_1d ) )  THEN
+         out_str = 'intwp'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_intwp_1d
       ELSEIF ( PRESENT( var_intwp_2d ) )  THEN
+         out_str = 'intwp'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_intwp_2d
       ELSEIF ( PRESENT( var_intwp_3d ) )  THEN
+         out_str = 'intwp'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_intwp_3d
       !-- 32bit real output
       ELSEIF ( PRESENT( var_real32_0d ) )  THEN
+         out_str = 'real32'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_real32_0d
       ELSEIF ( PRESENT( var_real32_1d ) )  THEN
+         out_str = 'real32'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_real32_1d
       ELSEIF ( PRESENT( var_real32_2d ) )  THEN
+         out_str = 'real32'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_real32_2d
       ELSEIF ( PRESENT( var_real32_3d ) )  THEN
+         out_str = 'real32'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_real32_3d
       !-- 64bit real output
       ELSEIF ( PRESENT( var_real64_0d ) )  THEN
+         out_str = 'real64'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_real64_0d
       ELSEIF ( PRESENT( var_real64_1d ) )  THEN
+         out_str = 'real64'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_real64_1d
       ELSEIF ( PRESENT( var_real64_2d ) )  THEN
+         out_str = 'real64'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_real64_2d
       ELSEIF ( PRESENT( var_real64_3d ) )  THEN
+         out_str = 'real64'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_real64_3d
       !-- working-precision real output
       ELSEIF ( PRESENT( var_realwp_0d ) )  THEN
+         out_str = 'realwp'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_realwp_0d
       ELSEIF ( PRESENT( var_realwp_1d ) )  THEN
+         out_str = 'realwp'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_realwp_1d
       ELSEIF ( PRESENT( var_realwp_2d ) )  THEN
+         out_str = 'realwp'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_realwp_2d
       ELSEIF ( PRESENT( var_realwp_3d ) )  THEN
+         out_str = 'realwp'
+         WRITE( file_id )  out_str
          WRITE( file_id )  var_realwp_3d
       ELSE
          return_value = 1
-         WRITE( temp_string, '(": variable_id=",I6,", file_id=",I6)' ) var_id, file_id
-         CALL internal_message( 'error', routine_name // &
-                                         TRIM( temp_string ) // ': no values given' )
+         CALL internal_message( 'error', routine_name // ': no values given' )
       ENDIF
 
@@ -706,5 +767,5 @@
    IF ( TRIM( level ) == 'error' )  THEN
 
-      WRITE( internal_error_message, '(A,A)' ) 'DOM ERROR: ', string
+      WRITE( internal_error_message, '(A,A)' ) ': ', string
 
    ELSEIF ( TRIM( level ) == 'debug'  .AND.  print_debug_output )  THEN
